#
# Conditional build:
%bcond_without	doc	# Sphinx documentation
%bcond_without	tests	# unit tests
%bcond_without	python2 # CPython 2.x module
%bcond_without	python3 # CPython 3.x module

%define	module	FormEncode
Summary:	HTML form validation, generation, and convertion package
Summary(pl.UTF-8):	Moduł do walidacji, tworzenia i konwersji formularzy HTML
Name:		python-%{module}
Version:	1.3.1
Release:	5
License:	PSF
Group:		Development/Languages/Python
#Source0Download: https://pypi.org/project/FormEncode/
Source0:	https://files.pythonhosted.org/packages/source/F/FormEncode/%{module}-%{version}.tar.gz
# Source0-md5:	16fbefb206064eb93a6719f054a19b3b
Patch0:		%{name}-pycountry.patch
Patch1:		versions.patch
URL:		http://formencode.org/
%if %{with python2}
BuildRequires:	python-modules >= 1:2.6
BuildRequires:	python-setuptools
%if %{with tests}
BuildRequires:	python-dns
BuildRequires:	python-nose
BuildRequires:	python-pycountry >= 16.10.23
%endif
%endif
%if %{with python3}
BuildRequires:	python3-2to3 >= 1:3.2
BuildRequires:	python3-modules >= 1:3.2
BuildRequires:	python3-setuptools
%if %{with tests}
BuildRequires:	python3-dns
BuildRequires:	python3-nose
BuildRequires:	python3-pycountry >= 16.10.23
%endif
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
BuildRequires:	sed >= 4.0
Requires:	python-modules >= 1:2.6
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
FormEncode validates and converts nested structures. It allows for a
declarative form of defining the validation, and decoupled processes
for filling and generating forms.

%description -l pl.UTF-8
FormEncode służy do sprawdzania poprawności i konwersji zagnieżdżonych
struktur. Pozwala na deklaratywny sposób definiowania reguł
poprawności i niezależne od nich wypełnianie i generowanie formularzy.

%package -n python3-%{module}
Summary:	HTML form validation, generation, and convertion package
Summary(pl.UTF-8):	Moduł do walidacji, tworzenia i konwersji formularzy HTML
Group:		Libraries/Python
Requires:	python3-modules >= 1:3.2

%description -n python3-%{module}
FormEncode validates and converts nested structures. It allows for a
declarative form of defining the validation, and decoupled processes
for filling and generating forms.

%description -n python3-%{module} -l pl.UTF-8
FormEncode służy do sprawdzania poprawności i konwersji zagnieżdżonych
struktur. Pozwala na deklaratywny sposób definiowania reguł
poprawności i niezależne od nich wypełnianie i generowanie formularzy.

%package apidocs
Summary:	API documentation for Python FormEncode module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona FormEncode
Group:		Documentation

%description apidocs
API documentation for Python FormEncode module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona FormEncode.

%prep
%setup -q -n %{module}-%{version}
%patch0 -p1
%patch1 -p1

# uses network to validate domains (with one no longer valid anyway)
%{__rm} formencode/tests/test_email.py
# validator doctests cover Email and URL validators which include DNS lookups
%{__sed} -i -e '/^modules / s/, validators//' formencode/tests/test_doctests.py

%build
%if %{with python2}
%py_build

%if %{with tests}
%{__python} -m nose build-2/lib/formencode/tests
%endif
%endif

%if %{with python3}
%py3_build

%if %{with tests}
%{__python3} -m nose build-3/lib/formencode/tests
%endif
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%py_install

%{__mv} $RPM_BUILD_ROOT%{py_sitescriptdir}/docs built-docs

%{__rm} -r $RPM_BUILD_ROOT%{py_sitescriptdir}/formencode/tests
%{__rm} $RPM_BUILD_ROOT%{py_sitescriptdir}/formencode/i18n/FormEncode.pot
%{__rm} $RPM_BUILD_ROOT%{py_sitescriptdir}/formencode/i18n/*/LC_MESSAGES/FormEncode.po
%py_postclean

find $RPM_BUILD_ROOT%{py_sitescriptdir}/formencode/i18n -type d -maxdepth 1 | \
	%{__sed} -ne "s,$RPM_BUILD_ROOT\(.*i18n/\([a-z]\+\(_[A-Z][A-Z]\)\?\).*\),%%lang(\2) \1,p" > py2.lang
%endif

%if %{with python3}
%py3_install

%{__rm} -rf built-docs
%{__mv} $RPM_BUILD_ROOT%{py3_sitescriptdir}/docs built-docs

%{__rm} -r $RPM_BUILD_ROOT%{py3_sitescriptdir}/formencode/tests
%{__rm} $RPM_BUILD_ROOT%{py3_sitescriptdir}/formencode/i18n/FormEncode.pot
%{__rm} $RPM_BUILD_ROOT%{py3_sitescriptdir}/formencode/i18n/*/LC_MESSAGES/FormEncode.po

find $RPM_BUILD_ROOT%{py3_sitescriptdir}/formencode/i18n -type d -maxdepth 1 | \
	%{__sed} -ne "s,$RPM_BUILD_ROOT\(.*i18n/\([a-z]\+\(_[A-Z][A-Z]\)\?\).*\),%%lang(\2) \1,p" > py3.lang
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files -f py2.lang
%defattr(644,root,root,755)
%doc README.rst
%dir %{py_sitescriptdir}/formencode
%{py_sitescriptdir}/formencode/*.py[co]
%dir %{py_sitescriptdir}/formencode/i18n
%{py_sitescriptdir}/formencode/javascript
%{py_sitescriptdir}/FormEncode-%{version}-py*.egg-info
%endif

%if %{with python3}
%files -n python3-%{module} -f py3.lang
%defattr(644,root,root,755)
%doc README.rst
%dir %{py3_sitescriptdir}/formencode
%{py3_sitescriptdir}/formencode/*.py
%{py3_sitescriptdir}/formencode/__pycache__
%dir %{py3_sitescriptdir}/formencode/i18n
%{py3_sitescriptdir}/formencode/javascript
%{py3_sitescriptdir}/FormEncode-%{version}-py*.egg-info
%endif

%files apidocs
%defattr(644,root,root,755)
%doc built-docs/*
%changelog
* Fri Apr 08 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-FormEncode.git;a=log;h=master

* Fri Apr 08 2022 Jan Rękorajski <baggins@pld-linux.org> 0b38746
- remove bogus version detection, rel 5

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> ba7e674
- rebuild with python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> dc50037
- rebuild with python 3.10

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> 3cf2490
- release 2 (by relup.sh)

* Tue Jun 09 2020 Jakub Bogusz <qboosh@pld-linux.org> edc83fe
- disable also validator doctests due to DNS lookups

* Tue Jun 09 2020 Jakub Bogusz <qboosh@pld-linux.org> d7c2098
- updated to 1.3.1
- added pycountry patch (adapt for pycountry 16.10.23 API change)
- added python3- and -apidocs packages

* Sun Nov 29 2015 Jacek Konieczny <jajcus@jajcus.net> 5b5e451
- BR: rpmbuild(macros) >= 1.710

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> dbb6612
- release 2 (by relup.sh)

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 3413432
- automatic change: use py_build/py_install macros

* Thu Jan 12 2012 zbyniu <zbyniu@pld-linux.org> 9ba635c
- up to 1.2.4

* Sat Nov 13 2010 pawelz <pawelz@pld-linux.org> 1d33453
- release 3

* Thu Jul 08 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 0238e9f
- release 2

* Sun Mar 15 2009 duddits <duddits@pld-linux.org> 632f4e5
- up to 1.2.2

* Sun Oct 19 2008 Arkadiusz Miśkiewicz <arekm@maven.pl> de2a59a
- up to 1.0.1

* Fri Sep 14 2007 beorn <beorn@pld-linux.org> 3e44363
- Up to 0.7.1

* Fri Sep 14 2007 beorn <beorn@pld-linux.org> c5f7c8e
- BR: python downgrade to 2.4 (2.5 is not required)
- Missing BR

* Tue Feb 13 2007 Elan Ruusamäe <glen@pld-linux.org> b27f05d
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> b70689e
- converted to UTF-8

* Tue Jan 02 2007 Arkadiusz Miśkiewicz <arekm@maven.pl> 3003934
- rel 2

* Tue Nov 28 2006 Jakub Bogusz <qboosh@pld-linux.org> ecaf098
- gpm-friendly Source0 URL, BR: rpm-pythonprov

